#ifndef _H_AE817A880DBBC1EB2A17AD1153D99EF6_ClearQueue__H_
#define _H_AE817A880DBBC1EB2A17AD1153D99EF6_ClearQueue__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            struct  ClearQueue_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<ClearQueue_Request_> ClearQueue_Request__var;
            typedef ClearQueue_Request_& ClearQueue_Request__out;

            struct  ClearQueue_Response_
            {
                ::DDS::Boolean status_;
            };

            typedef DDS_DCPSStruct_var<ClearQueue_Response_> ClearQueue_Response__var;
            typedef ClearQueue_Response_& ClearQueue_Response__out;

            struct  Sample_ClearQueue_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::ClearQueue_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ClearQueue_Request_> Sample_ClearQueue_Request__var;
            typedef Sample_ClearQueue_Request_& Sample_ClearQueue_Request__out;

            struct  Sample_ClearQueue_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::ClearQueue_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ClearQueue_Response_> Sample_ClearQueue_Response__var;
            typedef Sample_ClearQueue_Response_& Sample_ClearQueue_Response__out;

        }

    }

}

#endif /* _H_AE817A880DBBC1EB2A17AD1153D99EF6_ClearQueue__H_ */
