#ifndef _H_46B42BCE8857E57B6447EA061E9E890D_Clear__H_
#define _H_46B42BCE8857E57B6447EA061E9E890D_Clear__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            struct  Clear_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<Clear_Request_> Clear_Request__var;
            typedef Clear_Request_& Clear_Request__out;

            struct  Clear_Response_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<Clear_Response_> Clear_Response__var;
            typedef Clear_Response_& Clear_Response__out;

            struct  Sample_Clear_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::Clear_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Clear_Request_> Sample_Clear_Request__var;
            typedef Sample_Clear_Request_& Sample_Clear_Request__out;

            struct  Sample_Clear_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::Clear_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Clear_Response_> Sample_Clear_Response__var;
            typedef Sample_Clear_Response_& Sample_Clear_Response__out;

        }

    }

}

#endif /* _H_46B42BCE8857E57B6447EA061E9E890D_Clear__H_ */
