#ifndef _H_46B42BCE8857E57B6447EA061E9E890D_Clear_DCPS_H_
#define _H_46B42BCE8857E57B6447EA061E9E890D_Clear_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Clear_.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            class Clear_Request_TypeSupportInterface;

            typedef Clear_Request_TypeSupportInterface * Clear_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Clear_Request_TypeSupportInterface> Clear_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Clear_Request_TypeSupportInterface> Clear_Request_TypeSupportInterface_out;


            class Clear_Request_DataWriter;

            typedef Clear_Request_DataWriter * Clear_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Clear_Request_DataWriter> Clear_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Clear_Request_DataWriter> Clear_Request_DataWriter_out;


            class Clear_Request_DataReader;

            typedef Clear_Request_DataReader * Clear_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Clear_Request_DataReader> Clear_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Clear_Request_DataReader> Clear_Request_DataReader_out;


            class Clear_Request_DataReaderView;

            typedef Clear_Request_DataReaderView * Clear_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Clear_Request_DataReaderView> Clear_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Clear_Request_DataReaderView> Clear_Request_DataReaderView_out;

            struct Clear_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Clear_Request_, struct Clear_Request_Seq_uniq_> Clear_Request_Seq;
            typedef DDS_DCPSSequence_var < Clear_Request_Seq> Clear_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Clear_Request_Seq> Clear_Request_Seq_out;

            class  Clear_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Clear_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Clear_Request_TypeSupportInterface_var _var_type;

                static Clear_Request_TypeSupportInterface_ptr _duplicate (Clear_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Clear_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Clear_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Clear_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Clear_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Clear_Request_TypeSupportInterface () {};
                ~Clear_Request_TypeSupportInterface () {};
            private:
                Clear_Request_TypeSupportInterface (const Clear_Request_TypeSupportInterface &);
                Clear_Request_TypeSupportInterface & operator = (const Clear_Request_TypeSupportInterface &);
            };

            class  Clear_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Clear_Request_DataWriter_ptr _ptr_type;
                typedef Clear_Request_DataWriter_var _var_type;

                static Clear_Request_DataWriter_ptr _duplicate (Clear_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Clear_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Clear_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Clear_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Clear_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Clear_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Clear_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Clear_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Clear_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Clear_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Clear_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Clear_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Clear_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Clear_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Clear_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Clear_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Clear_Request_& instance_data) = 0;

            protected:
                Clear_Request_DataWriter () {};
                ~Clear_Request_DataWriter () {};
            private:
                Clear_Request_DataWriter (const Clear_Request_DataWriter &);
                Clear_Request_DataWriter & operator = (const Clear_Request_DataWriter &);
            };

            class  Clear_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Clear_Request_DataReader_ptr _ptr_type;
                typedef Clear_Request_DataReader_var _var_type;

                static Clear_Request_DataReader_ptr _duplicate (Clear_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Clear_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Clear_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Clear_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Clear_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Clear_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Clear_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Clear_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Clear_Request_& instance) = 0;

            protected:
                Clear_Request_DataReader () {};
                ~Clear_Request_DataReader () {};
            private:
                Clear_Request_DataReader (const Clear_Request_DataReader &);
                Clear_Request_DataReader & operator = (const Clear_Request_DataReader &);
            };

            class  Clear_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Clear_Request_DataReaderView_ptr _ptr_type;
                typedef Clear_Request_DataReaderView_var _var_type;

                static Clear_Request_DataReaderView_ptr _duplicate (Clear_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Clear_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Clear_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Clear_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Clear_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Clear_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Clear_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Clear_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Clear_Request_& instance) = 0;

            protected:
                Clear_Request_DataReaderView () {};
                ~Clear_Request_DataReaderView () {};
            private:
                Clear_Request_DataReaderView (const Clear_Request_DataReaderView &);
                Clear_Request_DataReaderView & operator = (const Clear_Request_DataReaderView &);
            };
            class Clear_Response_TypeSupportInterface;

            typedef Clear_Response_TypeSupportInterface * Clear_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Clear_Response_TypeSupportInterface> Clear_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Clear_Response_TypeSupportInterface> Clear_Response_TypeSupportInterface_out;


            class Clear_Response_DataWriter;

            typedef Clear_Response_DataWriter * Clear_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Clear_Response_DataWriter> Clear_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Clear_Response_DataWriter> Clear_Response_DataWriter_out;


            class Clear_Response_DataReader;

            typedef Clear_Response_DataReader * Clear_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Clear_Response_DataReader> Clear_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Clear_Response_DataReader> Clear_Response_DataReader_out;


            class Clear_Response_DataReaderView;

            typedef Clear_Response_DataReaderView * Clear_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Clear_Response_DataReaderView> Clear_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Clear_Response_DataReaderView> Clear_Response_DataReaderView_out;

            struct Clear_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Clear_Response_, struct Clear_Response_Seq_uniq_> Clear_Response_Seq;
            typedef DDS_DCPSSequence_var < Clear_Response_Seq> Clear_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Clear_Response_Seq> Clear_Response_Seq_out;

            class  Clear_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Clear_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Clear_Response_TypeSupportInterface_var _var_type;

                static Clear_Response_TypeSupportInterface_ptr _duplicate (Clear_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Clear_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Clear_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Clear_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Clear_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Clear_Response_TypeSupportInterface () {};
                ~Clear_Response_TypeSupportInterface () {};
            private:
                Clear_Response_TypeSupportInterface (const Clear_Response_TypeSupportInterface &);
                Clear_Response_TypeSupportInterface & operator = (const Clear_Response_TypeSupportInterface &);
            };

            class  Clear_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Clear_Response_DataWriter_ptr _ptr_type;
                typedef Clear_Response_DataWriter_var _var_type;

                static Clear_Response_DataWriter_ptr _duplicate (Clear_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Clear_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Clear_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Clear_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Clear_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Clear_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Clear_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Clear_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Clear_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Clear_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Clear_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Clear_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Clear_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Clear_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Clear_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Clear_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Clear_Response_& instance_data) = 0;

            protected:
                Clear_Response_DataWriter () {};
                ~Clear_Response_DataWriter () {};
            private:
                Clear_Response_DataWriter (const Clear_Response_DataWriter &);
                Clear_Response_DataWriter & operator = (const Clear_Response_DataWriter &);
            };

            class  Clear_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Clear_Response_DataReader_ptr _ptr_type;
                typedef Clear_Response_DataReader_var _var_type;

                static Clear_Response_DataReader_ptr _duplicate (Clear_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Clear_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Clear_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Clear_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Clear_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Clear_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Clear_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Clear_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Clear_Response_& instance) = 0;

            protected:
                Clear_Response_DataReader () {};
                ~Clear_Response_DataReader () {};
            private:
                Clear_Response_DataReader (const Clear_Response_DataReader &);
                Clear_Response_DataReader & operator = (const Clear_Response_DataReader &);
            };

            class  Clear_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Clear_Response_DataReaderView_ptr _ptr_type;
                typedef Clear_Response_DataReaderView_var _var_type;

                static Clear_Response_DataReaderView_ptr _duplicate (Clear_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Clear_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Clear_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Clear_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Clear_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Clear_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Clear_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Clear_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Clear_Response_& instance) = 0;

            protected:
                Clear_Response_DataReaderView () {};
                ~Clear_Response_DataReaderView () {};
            private:
                Clear_Response_DataReaderView (const Clear_Response_DataReaderView &);
                Clear_Response_DataReaderView & operator = (const Clear_Response_DataReaderView &);
            };
            class Sample_Clear_Request_TypeSupportInterface;

            typedef Sample_Clear_Request_TypeSupportInterface * Sample_Clear_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Clear_Request_TypeSupportInterface> Sample_Clear_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Clear_Request_TypeSupportInterface> Sample_Clear_Request_TypeSupportInterface_out;


            class Sample_Clear_Request_DataWriter;

            typedef Sample_Clear_Request_DataWriter * Sample_Clear_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Clear_Request_DataWriter> Sample_Clear_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Clear_Request_DataWriter> Sample_Clear_Request_DataWriter_out;


            class Sample_Clear_Request_DataReader;

            typedef Sample_Clear_Request_DataReader * Sample_Clear_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Clear_Request_DataReader> Sample_Clear_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Clear_Request_DataReader> Sample_Clear_Request_DataReader_out;


            class Sample_Clear_Request_DataReaderView;

            typedef Sample_Clear_Request_DataReaderView * Sample_Clear_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Clear_Request_DataReaderView> Sample_Clear_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Clear_Request_DataReaderView> Sample_Clear_Request_DataReaderView_out;

            struct Sample_Clear_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Clear_Request_, struct Sample_Clear_Request_Seq_uniq_> Sample_Clear_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_Clear_Request_Seq> Sample_Clear_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Clear_Request_Seq> Sample_Clear_Request_Seq_out;

            class  Sample_Clear_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Clear_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Clear_Request_TypeSupportInterface_var _var_type;

                static Sample_Clear_Request_TypeSupportInterface_ptr _duplicate (Sample_Clear_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Clear_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Clear_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Clear_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Clear_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Clear_Request_TypeSupportInterface () {};
                ~Sample_Clear_Request_TypeSupportInterface () {};
            private:
                Sample_Clear_Request_TypeSupportInterface (const Sample_Clear_Request_TypeSupportInterface &);
                Sample_Clear_Request_TypeSupportInterface & operator = (const Sample_Clear_Request_TypeSupportInterface &);
            };

            class  Sample_Clear_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Clear_Request_DataWriter_ptr _ptr_type;
                typedef Sample_Clear_Request_DataWriter_var _var_type;

                static Sample_Clear_Request_DataWriter_ptr _duplicate (Sample_Clear_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Clear_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Clear_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Clear_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Clear_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Clear_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Clear_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Clear_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Clear_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Clear_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Clear_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Clear_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Clear_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Clear_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Clear_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Clear_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Clear_Request_& instance_data) = 0;

            protected:
                Sample_Clear_Request_DataWriter () {};
                ~Sample_Clear_Request_DataWriter () {};
            private:
                Sample_Clear_Request_DataWriter (const Sample_Clear_Request_DataWriter &);
                Sample_Clear_Request_DataWriter & operator = (const Sample_Clear_Request_DataWriter &);
            };

            class  Sample_Clear_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Clear_Request_DataReader_ptr _ptr_type;
                typedef Sample_Clear_Request_DataReader_var _var_type;

                static Sample_Clear_Request_DataReader_ptr _duplicate (Sample_Clear_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Clear_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Clear_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Clear_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Clear_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Clear_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Clear_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Clear_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Clear_Request_& instance) = 0;

            protected:
                Sample_Clear_Request_DataReader () {};
                ~Sample_Clear_Request_DataReader () {};
            private:
                Sample_Clear_Request_DataReader (const Sample_Clear_Request_DataReader &);
                Sample_Clear_Request_DataReader & operator = (const Sample_Clear_Request_DataReader &);
            };

            class  Sample_Clear_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Clear_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_Clear_Request_DataReaderView_var _var_type;

                static Sample_Clear_Request_DataReaderView_ptr _duplicate (Sample_Clear_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Clear_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Clear_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Clear_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Clear_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Clear_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Clear_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Clear_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Clear_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Clear_Request_& instance) = 0;

            protected:
                Sample_Clear_Request_DataReaderView () {};
                ~Sample_Clear_Request_DataReaderView () {};
            private:
                Sample_Clear_Request_DataReaderView (const Sample_Clear_Request_DataReaderView &);
                Sample_Clear_Request_DataReaderView & operator = (const Sample_Clear_Request_DataReaderView &);
            };
            class Sample_Clear_Response_TypeSupportInterface;

            typedef Sample_Clear_Response_TypeSupportInterface * Sample_Clear_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Clear_Response_TypeSupportInterface> Sample_Clear_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Clear_Response_TypeSupportInterface> Sample_Clear_Response_TypeSupportInterface_out;


            class Sample_Clear_Response_DataWriter;

            typedef Sample_Clear_Response_DataWriter * Sample_Clear_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Clear_Response_DataWriter> Sample_Clear_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Clear_Response_DataWriter> Sample_Clear_Response_DataWriter_out;


            class Sample_Clear_Response_DataReader;

            typedef Sample_Clear_Response_DataReader * Sample_Clear_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Clear_Response_DataReader> Sample_Clear_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Clear_Response_DataReader> Sample_Clear_Response_DataReader_out;


            class Sample_Clear_Response_DataReaderView;

            typedef Sample_Clear_Response_DataReaderView * Sample_Clear_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Clear_Response_DataReaderView> Sample_Clear_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Clear_Response_DataReaderView> Sample_Clear_Response_DataReaderView_out;

            struct Sample_Clear_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Clear_Response_, struct Sample_Clear_Response_Seq_uniq_> Sample_Clear_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_Clear_Response_Seq> Sample_Clear_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Clear_Response_Seq> Sample_Clear_Response_Seq_out;

            class  Sample_Clear_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Clear_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Clear_Response_TypeSupportInterface_var _var_type;

                static Sample_Clear_Response_TypeSupportInterface_ptr _duplicate (Sample_Clear_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Clear_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Clear_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Clear_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Clear_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Clear_Response_TypeSupportInterface () {};
                ~Sample_Clear_Response_TypeSupportInterface () {};
            private:
                Sample_Clear_Response_TypeSupportInterface (const Sample_Clear_Response_TypeSupportInterface &);
                Sample_Clear_Response_TypeSupportInterface & operator = (const Sample_Clear_Response_TypeSupportInterface &);
            };

            class  Sample_Clear_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Clear_Response_DataWriter_ptr _ptr_type;
                typedef Sample_Clear_Response_DataWriter_var _var_type;

                static Sample_Clear_Response_DataWriter_ptr _duplicate (Sample_Clear_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Clear_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Clear_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Clear_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Clear_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Clear_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Clear_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Clear_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Clear_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Clear_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Clear_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Clear_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Clear_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Clear_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Clear_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Clear_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Clear_Response_& instance_data) = 0;

            protected:
                Sample_Clear_Response_DataWriter () {};
                ~Sample_Clear_Response_DataWriter () {};
            private:
                Sample_Clear_Response_DataWriter (const Sample_Clear_Response_DataWriter &);
                Sample_Clear_Response_DataWriter & operator = (const Sample_Clear_Response_DataWriter &);
            };

            class  Sample_Clear_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Clear_Response_DataReader_ptr _ptr_type;
                typedef Sample_Clear_Response_DataReader_var _var_type;

                static Sample_Clear_Response_DataReader_ptr _duplicate (Sample_Clear_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Clear_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Clear_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Clear_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Clear_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Clear_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Clear_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Clear_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Clear_Response_& instance) = 0;

            protected:
                Sample_Clear_Response_DataReader () {};
                ~Sample_Clear_Response_DataReader () {};
            private:
                Sample_Clear_Response_DataReader (const Sample_Clear_Response_DataReader &);
                Sample_Clear_Response_DataReader & operator = (const Sample_Clear_Response_DataReader &);
            };

            class  Sample_Clear_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Clear_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_Clear_Response_DataReaderView_var _var_type;

                static Sample_Clear_Response_DataReaderView_ptr _duplicate (Sample_Clear_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Clear_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Clear_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Clear_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Clear_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Clear_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Clear_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Clear_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Clear_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Clear_Response_& instance) = 0;

            protected:
                Sample_Clear_Response_DataReaderView () {};
                ~Sample_Clear_Response_DataReaderView () {};
            private:
                Sample_Clear_Response_DataReaderView (const Sample_Clear_Response_DataReaderView &);
                Sample_Clear_Response_DataReaderView & operator = (const Sample_Clear_Response_DataReaderView &);
            };
        }

    }

}

#endif
