#ifndef H_14059351A3F3A6DDF6642B2015AE2039_DeserializePoseGraph_SPLTYPES_H
#define H_14059351A3F3A6DDF6642B2015AE2039_DeserializePoseGraph_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_DeserializePoseGraph_.h"
#include "geometry_msgs/msg/dds_opensplice/Pose2D_SplDcps.h"



extern c_metaObject __DeserializePoseGraph__slam_toolbox__load (c_base base);

extern c_metaObject __DeserializePoseGraph__slam_toolbox_srv__load (c_base base);

extern c_metaObject __DeserializePoseGraph__slam_toolbox_srv_dds___load (c_base base);

extern c_metaObject __DeserializePoseGraph__slam_toolbox_srv_dds__DeserializePoseGraph_Request_Constants__load (c_base base);

extern const char *slam_toolbox_srv_dds__DeserializePoseGraph_Request__metaDescriptor[];
extern const int slam_toolbox_srv_dds__DeserializePoseGraph_Request__metaDescriptorArrLength;
extern const int slam_toolbox_srv_dds__DeserializePoseGraph_Request__metaDescriptorLength;
extern c_metaObject __slam_toolbox_srv_dds__DeserializePoseGraph_Request___load (c_base base);
struct _slam_toolbox_srv_dds__DeserializePoseGraph_Request_ ;
extern  v_copyin_result __slam_toolbox_srv_dds__DeserializePoseGraph_Request___copyIn(c_base base, const struct slam_toolbox::srv::dds_::DeserializePoseGraph_Request_ *from, struct _slam_toolbox_srv_dds__DeserializePoseGraph_Request_ *to);
extern  void __slam_toolbox_srv_dds__DeserializePoseGraph_Request___copyOut(const void *_from, void *_to);
struct _slam_toolbox_srv_dds__DeserializePoseGraph_Request_ {
    c_string filename_;
    c_octet match_type_;
    struct _geometry_msgs_msg_dds__Pose2D_ initial_pose_;
};

extern const char *slam_toolbox_srv_dds__DeserializePoseGraph_Response__metaDescriptor[];
extern const int slam_toolbox_srv_dds__DeserializePoseGraph_Response__metaDescriptorArrLength;
extern const int slam_toolbox_srv_dds__DeserializePoseGraph_Response__metaDescriptorLength;
extern c_metaObject __slam_toolbox_srv_dds__DeserializePoseGraph_Response___load (c_base base);
struct _slam_toolbox_srv_dds__DeserializePoseGraph_Response_ ;
extern  v_copyin_result __slam_toolbox_srv_dds__DeserializePoseGraph_Response___copyIn(c_base base, const struct slam_toolbox::srv::dds_::DeserializePoseGraph_Response_ *from, struct _slam_toolbox_srv_dds__DeserializePoseGraph_Response_ *to);
extern  void __slam_toolbox_srv_dds__DeserializePoseGraph_Response___copyOut(const void *_from, void *_to);
struct _slam_toolbox_srv_dds__DeserializePoseGraph_Response_ {
    c_octet structure_needs_at_least_one_member_;
};

extern const char *slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Request__metaDescriptor[];
extern const int slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Request__metaDescriptorArrLength;
extern const int slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Request__metaDescriptorLength;
extern c_metaObject __slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Request___load (c_base base);
struct _slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Request_ ;
extern  v_copyin_result __slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Request___copyIn(c_base base, const struct slam_toolbox::srv::dds_::Sample_DeserializePoseGraph_Request_ *from, struct _slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Request_ *to);
extern  void __slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Request___copyOut(const void *_from, void *_to);
struct _slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _slam_toolbox_srv_dds__DeserializePoseGraph_Request_ request_;
};

extern const char *slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Response__metaDescriptor[];
extern const int slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Response__metaDescriptorArrLength;
extern const int slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Response__metaDescriptorLength;
extern c_metaObject __slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Response___load (c_base base);
struct _slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Response_ ;
extern  v_copyin_result __slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Response___copyIn(c_base base, const struct slam_toolbox::srv::dds_::Sample_DeserializePoseGraph_Response_ *from, struct _slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Response_ *to);
extern  void __slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Response___copyOut(const void *_from, void *_to);
struct _slam_toolbox_srv_dds__Sample_DeserializePoseGraph_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _slam_toolbox_srv_dds__DeserializePoseGraph_Response_ response_;
};

#undef OS_API
#endif
