#ifndef _H_C22100C118246AA45897BA28971298EC_MergeMaps_DCPS_H_
#define _H_C22100C118246AA45897BA28971298EC_MergeMaps_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MergeMaps_.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            class MergeMaps_Request_TypeSupportInterface;

            typedef MergeMaps_Request_TypeSupportInterface * MergeMaps_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MergeMaps_Request_TypeSupportInterface> MergeMaps_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MergeMaps_Request_TypeSupportInterface> MergeMaps_Request_TypeSupportInterface_out;


            class MergeMaps_Request_DataWriter;

            typedef MergeMaps_Request_DataWriter * MergeMaps_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MergeMaps_Request_DataWriter> MergeMaps_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < MergeMaps_Request_DataWriter> MergeMaps_Request_DataWriter_out;


            class MergeMaps_Request_DataReader;

            typedef MergeMaps_Request_DataReader * MergeMaps_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MergeMaps_Request_DataReader> MergeMaps_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < MergeMaps_Request_DataReader> MergeMaps_Request_DataReader_out;


            class MergeMaps_Request_DataReaderView;

            typedef MergeMaps_Request_DataReaderView * MergeMaps_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MergeMaps_Request_DataReaderView> MergeMaps_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MergeMaps_Request_DataReaderView> MergeMaps_Request_DataReaderView_out;

            struct MergeMaps_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < MergeMaps_Request_, struct MergeMaps_Request_Seq_uniq_> MergeMaps_Request_Seq;
            typedef DDS_DCPSSequence_var < MergeMaps_Request_Seq> MergeMaps_Request_Seq_var;
            typedef DDS_DCPSSequence_out < MergeMaps_Request_Seq> MergeMaps_Request_Seq_out;

            class  MergeMaps_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MergeMaps_Request_TypeSupportInterface_ptr _ptr_type;
                typedef MergeMaps_Request_TypeSupportInterface_var _var_type;

                static MergeMaps_Request_TypeSupportInterface_ptr _duplicate (MergeMaps_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MergeMaps_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MergeMaps_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MergeMaps_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MergeMaps_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MergeMaps_Request_TypeSupportInterface () {};
                ~MergeMaps_Request_TypeSupportInterface () {};
            private:
                MergeMaps_Request_TypeSupportInterface (const MergeMaps_Request_TypeSupportInterface &);
                MergeMaps_Request_TypeSupportInterface & operator = (const MergeMaps_Request_TypeSupportInterface &);
            };

            class  MergeMaps_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MergeMaps_Request_DataWriter_ptr _ptr_type;
                typedef MergeMaps_Request_DataWriter_var _var_type;

                static MergeMaps_Request_DataWriter_ptr _duplicate (MergeMaps_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MergeMaps_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MergeMaps_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MergeMaps_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MergeMaps_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MergeMaps_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MergeMaps_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MergeMaps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MergeMaps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MergeMaps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MergeMaps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MergeMaps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MergeMaps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MergeMaps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MergeMaps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MergeMaps_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MergeMaps_Request_& instance_data) = 0;

            protected:
                MergeMaps_Request_DataWriter () {};
                ~MergeMaps_Request_DataWriter () {};
            private:
                MergeMaps_Request_DataWriter (const MergeMaps_Request_DataWriter &);
                MergeMaps_Request_DataWriter & operator = (const MergeMaps_Request_DataWriter &);
            };

            class  MergeMaps_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MergeMaps_Request_DataReader_ptr _ptr_type;
                typedef MergeMaps_Request_DataReader_var _var_type;

                static MergeMaps_Request_DataReader_ptr _duplicate (MergeMaps_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MergeMaps_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MergeMaps_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MergeMaps_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MergeMaps_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MergeMaps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MergeMaps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MergeMaps_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MergeMaps_Request_& instance) = 0;

            protected:
                MergeMaps_Request_DataReader () {};
                ~MergeMaps_Request_DataReader () {};
            private:
                MergeMaps_Request_DataReader (const MergeMaps_Request_DataReader &);
                MergeMaps_Request_DataReader & operator = (const MergeMaps_Request_DataReader &);
            };

            class  MergeMaps_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MergeMaps_Request_DataReaderView_ptr _ptr_type;
                typedef MergeMaps_Request_DataReaderView_var _var_type;

                static MergeMaps_Request_DataReaderView_ptr _duplicate (MergeMaps_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MergeMaps_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MergeMaps_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MergeMaps_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MergeMaps_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MergeMaps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MergeMaps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MergeMaps_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MergeMaps_Request_& instance) = 0;

            protected:
                MergeMaps_Request_DataReaderView () {};
                ~MergeMaps_Request_DataReaderView () {};
            private:
                MergeMaps_Request_DataReaderView (const MergeMaps_Request_DataReaderView &);
                MergeMaps_Request_DataReaderView & operator = (const MergeMaps_Request_DataReaderView &);
            };
            class MergeMaps_Response_TypeSupportInterface;

            typedef MergeMaps_Response_TypeSupportInterface * MergeMaps_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MergeMaps_Response_TypeSupportInterface> MergeMaps_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MergeMaps_Response_TypeSupportInterface> MergeMaps_Response_TypeSupportInterface_out;


            class MergeMaps_Response_DataWriter;

            typedef MergeMaps_Response_DataWriter * MergeMaps_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MergeMaps_Response_DataWriter> MergeMaps_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < MergeMaps_Response_DataWriter> MergeMaps_Response_DataWriter_out;


            class MergeMaps_Response_DataReader;

            typedef MergeMaps_Response_DataReader * MergeMaps_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MergeMaps_Response_DataReader> MergeMaps_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < MergeMaps_Response_DataReader> MergeMaps_Response_DataReader_out;


            class MergeMaps_Response_DataReaderView;

            typedef MergeMaps_Response_DataReaderView * MergeMaps_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MergeMaps_Response_DataReaderView> MergeMaps_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MergeMaps_Response_DataReaderView> MergeMaps_Response_DataReaderView_out;

            struct MergeMaps_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < MergeMaps_Response_, struct MergeMaps_Response_Seq_uniq_> MergeMaps_Response_Seq;
            typedef DDS_DCPSSequence_var < MergeMaps_Response_Seq> MergeMaps_Response_Seq_var;
            typedef DDS_DCPSSequence_out < MergeMaps_Response_Seq> MergeMaps_Response_Seq_out;

            class  MergeMaps_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MergeMaps_Response_TypeSupportInterface_ptr _ptr_type;
                typedef MergeMaps_Response_TypeSupportInterface_var _var_type;

                static MergeMaps_Response_TypeSupportInterface_ptr _duplicate (MergeMaps_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MergeMaps_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MergeMaps_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MergeMaps_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MergeMaps_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MergeMaps_Response_TypeSupportInterface () {};
                ~MergeMaps_Response_TypeSupportInterface () {};
            private:
                MergeMaps_Response_TypeSupportInterface (const MergeMaps_Response_TypeSupportInterface &);
                MergeMaps_Response_TypeSupportInterface & operator = (const MergeMaps_Response_TypeSupportInterface &);
            };

            class  MergeMaps_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MergeMaps_Response_DataWriter_ptr _ptr_type;
                typedef MergeMaps_Response_DataWriter_var _var_type;

                static MergeMaps_Response_DataWriter_ptr _duplicate (MergeMaps_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MergeMaps_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MergeMaps_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MergeMaps_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MergeMaps_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MergeMaps_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MergeMaps_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MergeMaps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MergeMaps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MergeMaps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MergeMaps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MergeMaps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MergeMaps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MergeMaps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MergeMaps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MergeMaps_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MergeMaps_Response_& instance_data) = 0;

            protected:
                MergeMaps_Response_DataWriter () {};
                ~MergeMaps_Response_DataWriter () {};
            private:
                MergeMaps_Response_DataWriter (const MergeMaps_Response_DataWriter &);
                MergeMaps_Response_DataWriter & operator = (const MergeMaps_Response_DataWriter &);
            };

            class  MergeMaps_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MergeMaps_Response_DataReader_ptr _ptr_type;
                typedef MergeMaps_Response_DataReader_var _var_type;

                static MergeMaps_Response_DataReader_ptr _duplicate (MergeMaps_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MergeMaps_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MergeMaps_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MergeMaps_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MergeMaps_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MergeMaps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MergeMaps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MergeMaps_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MergeMaps_Response_& instance) = 0;

            protected:
                MergeMaps_Response_DataReader () {};
                ~MergeMaps_Response_DataReader () {};
            private:
                MergeMaps_Response_DataReader (const MergeMaps_Response_DataReader &);
                MergeMaps_Response_DataReader & operator = (const MergeMaps_Response_DataReader &);
            };

            class  MergeMaps_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MergeMaps_Response_DataReaderView_ptr _ptr_type;
                typedef MergeMaps_Response_DataReaderView_var _var_type;

                static MergeMaps_Response_DataReaderView_ptr _duplicate (MergeMaps_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MergeMaps_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MergeMaps_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MergeMaps_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MergeMaps_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MergeMaps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MergeMaps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MergeMaps_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MergeMaps_Response_& instance) = 0;

            protected:
                MergeMaps_Response_DataReaderView () {};
                ~MergeMaps_Response_DataReaderView () {};
            private:
                MergeMaps_Response_DataReaderView (const MergeMaps_Response_DataReaderView &);
                MergeMaps_Response_DataReaderView & operator = (const MergeMaps_Response_DataReaderView &);
            };
            class Sample_MergeMaps_Request_TypeSupportInterface;

            typedef Sample_MergeMaps_Request_TypeSupportInterface * Sample_MergeMaps_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_MergeMaps_Request_TypeSupportInterface> Sample_MergeMaps_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_MergeMaps_Request_TypeSupportInterface> Sample_MergeMaps_Request_TypeSupportInterface_out;


            class Sample_MergeMaps_Request_DataWriter;

            typedef Sample_MergeMaps_Request_DataWriter * Sample_MergeMaps_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_MergeMaps_Request_DataWriter> Sample_MergeMaps_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_MergeMaps_Request_DataWriter> Sample_MergeMaps_Request_DataWriter_out;


            class Sample_MergeMaps_Request_DataReader;

            typedef Sample_MergeMaps_Request_DataReader * Sample_MergeMaps_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_MergeMaps_Request_DataReader> Sample_MergeMaps_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_MergeMaps_Request_DataReader> Sample_MergeMaps_Request_DataReader_out;


            class Sample_MergeMaps_Request_DataReaderView;

            typedef Sample_MergeMaps_Request_DataReaderView * Sample_MergeMaps_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_MergeMaps_Request_DataReaderView> Sample_MergeMaps_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_MergeMaps_Request_DataReaderView> Sample_MergeMaps_Request_DataReaderView_out;

            struct Sample_MergeMaps_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_MergeMaps_Request_, struct Sample_MergeMaps_Request_Seq_uniq_> Sample_MergeMaps_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_MergeMaps_Request_Seq> Sample_MergeMaps_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_MergeMaps_Request_Seq> Sample_MergeMaps_Request_Seq_out;

            class  Sample_MergeMaps_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_MergeMaps_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_MergeMaps_Request_TypeSupportInterface_var _var_type;

                static Sample_MergeMaps_Request_TypeSupportInterface_ptr _duplicate (Sample_MergeMaps_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MergeMaps_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MergeMaps_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_MergeMaps_Request_TypeSupportInterface () {};
                ~Sample_MergeMaps_Request_TypeSupportInterface () {};
            private:
                Sample_MergeMaps_Request_TypeSupportInterface (const Sample_MergeMaps_Request_TypeSupportInterface &);
                Sample_MergeMaps_Request_TypeSupportInterface & operator = (const Sample_MergeMaps_Request_TypeSupportInterface &);
            };

            class  Sample_MergeMaps_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_MergeMaps_Request_DataWriter_ptr _ptr_type;
                typedef Sample_MergeMaps_Request_DataWriter_var _var_type;

                static Sample_MergeMaps_Request_DataWriter_ptr _duplicate (Sample_MergeMaps_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MergeMaps_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MergeMaps_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_MergeMaps_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_MergeMaps_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_MergeMaps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_MergeMaps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_MergeMaps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_MergeMaps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_MergeMaps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_MergeMaps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_MergeMaps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_MergeMaps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_MergeMaps_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_MergeMaps_Request_& instance_data) = 0;

            protected:
                Sample_MergeMaps_Request_DataWriter () {};
                ~Sample_MergeMaps_Request_DataWriter () {};
            private:
                Sample_MergeMaps_Request_DataWriter (const Sample_MergeMaps_Request_DataWriter &);
                Sample_MergeMaps_Request_DataWriter & operator = (const Sample_MergeMaps_Request_DataWriter &);
            };

            class  Sample_MergeMaps_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_MergeMaps_Request_DataReader_ptr _ptr_type;
                typedef Sample_MergeMaps_Request_DataReader_var _var_type;

                static Sample_MergeMaps_Request_DataReader_ptr _duplicate (Sample_MergeMaps_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MergeMaps_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MergeMaps_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_MergeMaps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_MergeMaps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_MergeMaps_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_MergeMaps_Request_& instance) = 0;

            protected:
                Sample_MergeMaps_Request_DataReader () {};
                ~Sample_MergeMaps_Request_DataReader () {};
            private:
                Sample_MergeMaps_Request_DataReader (const Sample_MergeMaps_Request_DataReader &);
                Sample_MergeMaps_Request_DataReader & operator = (const Sample_MergeMaps_Request_DataReader &);
            };

            class  Sample_MergeMaps_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_MergeMaps_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_MergeMaps_Request_DataReaderView_var _var_type;

                static Sample_MergeMaps_Request_DataReaderView_ptr _duplicate (Sample_MergeMaps_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MergeMaps_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MergeMaps_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_MergeMaps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_MergeMaps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_MergeMaps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_MergeMaps_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_MergeMaps_Request_& instance) = 0;

            protected:
                Sample_MergeMaps_Request_DataReaderView () {};
                ~Sample_MergeMaps_Request_DataReaderView () {};
            private:
                Sample_MergeMaps_Request_DataReaderView (const Sample_MergeMaps_Request_DataReaderView &);
                Sample_MergeMaps_Request_DataReaderView & operator = (const Sample_MergeMaps_Request_DataReaderView &);
            };
            class Sample_MergeMaps_Response_TypeSupportInterface;

            typedef Sample_MergeMaps_Response_TypeSupportInterface * Sample_MergeMaps_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_MergeMaps_Response_TypeSupportInterface> Sample_MergeMaps_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_MergeMaps_Response_TypeSupportInterface> Sample_MergeMaps_Response_TypeSupportInterface_out;


            class Sample_MergeMaps_Response_DataWriter;

            typedef Sample_MergeMaps_Response_DataWriter * Sample_MergeMaps_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_MergeMaps_Response_DataWriter> Sample_MergeMaps_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_MergeMaps_Response_DataWriter> Sample_MergeMaps_Response_DataWriter_out;


            class Sample_MergeMaps_Response_DataReader;

            typedef Sample_MergeMaps_Response_DataReader * Sample_MergeMaps_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_MergeMaps_Response_DataReader> Sample_MergeMaps_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_MergeMaps_Response_DataReader> Sample_MergeMaps_Response_DataReader_out;


            class Sample_MergeMaps_Response_DataReaderView;

            typedef Sample_MergeMaps_Response_DataReaderView * Sample_MergeMaps_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_MergeMaps_Response_DataReaderView> Sample_MergeMaps_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_MergeMaps_Response_DataReaderView> Sample_MergeMaps_Response_DataReaderView_out;

            struct Sample_MergeMaps_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_MergeMaps_Response_, struct Sample_MergeMaps_Response_Seq_uniq_> Sample_MergeMaps_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_MergeMaps_Response_Seq> Sample_MergeMaps_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_MergeMaps_Response_Seq> Sample_MergeMaps_Response_Seq_out;

            class  Sample_MergeMaps_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_MergeMaps_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_MergeMaps_Response_TypeSupportInterface_var _var_type;

                static Sample_MergeMaps_Response_TypeSupportInterface_ptr _duplicate (Sample_MergeMaps_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MergeMaps_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MergeMaps_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_MergeMaps_Response_TypeSupportInterface () {};
                ~Sample_MergeMaps_Response_TypeSupportInterface () {};
            private:
                Sample_MergeMaps_Response_TypeSupportInterface (const Sample_MergeMaps_Response_TypeSupportInterface &);
                Sample_MergeMaps_Response_TypeSupportInterface & operator = (const Sample_MergeMaps_Response_TypeSupportInterface &);
            };

            class  Sample_MergeMaps_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_MergeMaps_Response_DataWriter_ptr _ptr_type;
                typedef Sample_MergeMaps_Response_DataWriter_var _var_type;

                static Sample_MergeMaps_Response_DataWriter_ptr _duplicate (Sample_MergeMaps_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MergeMaps_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MergeMaps_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_MergeMaps_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_MergeMaps_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_MergeMaps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_MergeMaps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_MergeMaps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_MergeMaps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_MergeMaps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_MergeMaps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_MergeMaps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_MergeMaps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_MergeMaps_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_MergeMaps_Response_& instance_data) = 0;

            protected:
                Sample_MergeMaps_Response_DataWriter () {};
                ~Sample_MergeMaps_Response_DataWriter () {};
            private:
                Sample_MergeMaps_Response_DataWriter (const Sample_MergeMaps_Response_DataWriter &);
                Sample_MergeMaps_Response_DataWriter & operator = (const Sample_MergeMaps_Response_DataWriter &);
            };

            class  Sample_MergeMaps_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_MergeMaps_Response_DataReader_ptr _ptr_type;
                typedef Sample_MergeMaps_Response_DataReader_var _var_type;

                static Sample_MergeMaps_Response_DataReader_ptr _duplicate (Sample_MergeMaps_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MergeMaps_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MergeMaps_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_MergeMaps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_MergeMaps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_MergeMaps_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_MergeMaps_Response_& instance) = 0;

            protected:
                Sample_MergeMaps_Response_DataReader () {};
                ~Sample_MergeMaps_Response_DataReader () {};
            private:
                Sample_MergeMaps_Response_DataReader (const Sample_MergeMaps_Response_DataReader &);
                Sample_MergeMaps_Response_DataReader & operator = (const Sample_MergeMaps_Response_DataReader &);
            };

            class  Sample_MergeMaps_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_MergeMaps_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_MergeMaps_Response_DataReaderView_var _var_type;

                static Sample_MergeMaps_Response_DataReaderView_ptr _duplicate (Sample_MergeMaps_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_MergeMaps_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_MergeMaps_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_MergeMaps_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_MergeMaps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_MergeMaps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_MergeMaps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_MergeMaps_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_MergeMaps_Response_& instance) = 0;

            protected:
                Sample_MergeMaps_Response_DataReaderView () {};
                ~Sample_MergeMaps_Response_DataReaderView () {};
            private:
                Sample_MergeMaps_Response_DataReaderView (const Sample_MergeMaps_Response_DataReaderView &);
                Sample_MergeMaps_Response_DataReaderView & operator = (const Sample_MergeMaps_Response_DataReaderView &);
            };
        }

    }

}

#endif
