#ifndef _H_3E6936C6ADB392E30FB27AFB003073EB_Pause__H_
#define _H_3E6936C6ADB392E30FB27AFB003073EB_Pause__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            struct  Pause_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<Pause_Request_> Pause_Request__var;
            typedef Pause_Request_& Pause_Request__out;

            struct  Pause_Response_
            {
                ::DDS::Boolean status_;
            };

            typedef DDS_DCPSStruct_var<Pause_Response_> Pause_Response__var;
            typedef Pause_Response_& Pause_Response__out;

            struct  Sample_Pause_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::Pause_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Pause_Request_> Sample_Pause_Request__var;
            typedef Sample_Pause_Request_& Sample_Pause_Request__out;

            struct  Sample_Pause_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::Pause_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Pause_Response_> Sample_Pause_Response__var;
            typedef Sample_Pause_Response_& Sample_Pause_Response__out;

        }

    }

}

#endif /* _H_3E6936C6ADB392E30FB27AFB003073EB_Pause__H_ */
