#ifndef _H_034957473F4A2A2DDB62BCF92EF7B7AA_ToggleInteractive_DCPS_H_
#define _H_034957473F4A2A2DDB62BCF92EF7B7AA_ToggleInteractive_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ToggleInteractive_.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            class ToggleInteractive_Request_TypeSupportInterface;

            typedef ToggleInteractive_Request_TypeSupportInterface * ToggleInteractive_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ToggleInteractive_Request_TypeSupportInterface> ToggleInteractive_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ToggleInteractive_Request_TypeSupportInterface> ToggleInteractive_Request_TypeSupportInterface_out;


            class ToggleInteractive_Request_DataWriter;

            typedef ToggleInteractive_Request_DataWriter * ToggleInteractive_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ToggleInteractive_Request_DataWriter> ToggleInteractive_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ToggleInteractive_Request_DataWriter> ToggleInteractive_Request_DataWriter_out;


            class ToggleInteractive_Request_DataReader;

            typedef ToggleInteractive_Request_DataReader * ToggleInteractive_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ToggleInteractive_Request_DataReader> ToggleInteractive_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ToggleInteractive_Request_DataReader> ToggleInteractive_Request_DataReader_out;


            class ToggleInteractive_Request_DataReaderView;

            typedef ToggleInteractive_Request_DataReaderView * ToggleInteractive_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ToggleInteractive_Request_DataReaderView> ToggleInteractive_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ToggleInteractive_Request_DataReaderView> ToggleInteractive_Request_DataReaderView_out;

            struct ToggleInteractive_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ToggleInteractive_Request_, struct ToggleInteractive_Request_Seq_uniq_> ToggleInteractive_Request_Seq;
            typedef DDS_DCPSSequence_var < ToggleInteractive_Request_Seq> ToggleInteractive_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ToggleInteractive_Request_Seq> ToggleInteractive_Request_Seq_out;

            class  ToggleInteractive_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ToggleInteractive_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ToggleInteractive_Request_TypeSupportInterface_var _var_type;

                static ToggleInteractive_Request_TypeSupportInterface_ptr _duplicate (ToggleInteractive_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ToggleInteractive_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ToggleInteractive_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ToggleInteractive_Request_TypeSupportInterface () {};
                ~ToggleInteractive_Request_TypeSupportInterface () {};
            private:
                ToggleInteractive_Request_TypeSupportInterface (const ToggleInteractive_Request_TypeSupportInterface &);
                ToggleInteractive_Request_TypeSupportInterface & operator = (const ToggleInteractive_Request_TypeSupportInterface &);
            };

            class  ToggleInteractive_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ToggleInteractive_Request_DataWriter_ptr _ptr_type;
                typedef ToggleInteractive_Request_DataWriter_var _var_type;

                static ToggleInteractive_Request_DataWriter_ptr _duplicate (ToggleInteractive_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ToggleInteractive_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ToggleInteractive_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ToggleInteractive_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ToggleInteractive_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ToggleInteractive_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ToggleInteractive_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ToggleInteractive_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ToggleInteractive_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ToggleInteractive_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ToggleInteractive_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ToggleInteractive_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ToggleInteractive_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ToggleInteractive_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ToggleInteractive_Request_& instance_data) = 0;

            protected:
                ToggleInteractive_Request_DataWriter () {};
                ~ToggleInteractive_Request_DataWriter () {};
            private:
                ToggleInteractive_Request_DataWriter (const ToggleInteractive_Request_DataWriter &);
                ToggleInteractive_Request_DataWriter & operator = (const ToggleInteractive_Request_DataWriter &);
            };

            class  ToggleInteractive_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ToggleInteractive_Request_DataReader_ptr _ptr_type;
                typedef ToggleInteractive_Request_DataReader_var _var_type;

                static ToggleInteractive_Request_DataReader_ptr _duplicate (ToggleInteractive_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ToggleInteractive_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ToggleInteractive_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ToggleInteractive_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ToggleInteractive_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ToggleInteractive_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ToggleInteractive_Request_& instance) = 0;

            protected:
                ToggleInteractive_Request_DataReader () {};
                ~ToggleInteractive_Request_DataReader () {};
            private:
                ToggleInteractive_Request_DataReader (const ToggleInteractive_Request_DataReader &);
                ToggleInteractive_Request_DataReader & operator = (const ToggleInteractive_Request_DataReader &);
            };

            class  ToggleInteractive_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ToggleInteractive_Request_DataReaderView_ptr _ptr_type;
                typedef ToggleInteractive_Request_DataReaderView_var _var_type;

                static ToggleInteractive_Request_DataReaderView_ptr _duplicate (ToggleInteractive_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ToggleInteractive_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ToggleInteractive_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ToggleInteractive_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ToggleInteractive_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ToggleInteractive_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ToggleInteractive_Request_& instance) = 0;

            protected:
                ToggleInteractive_Request_DataReaderView () {};
                ~ToggleInteractive_Request_DataReaderView () {};
            private:
                ToggleInteractive_Request_DataReaderView (const ToggleInteractive_Request_DataReaderView &);
                ToggleInteractive_Request_DataReaderView & operator = (const ToggleInteractive_Request_DataReaderView &);
            };
            class ToggleInteractive_Response_TypeSupportInterface;

            typedef ToggleInteractive_Response_TypeSupportInterface * ToggleInteractive_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ToggleInteractive_Response_TypeSupportInterface> ToggleInteractive_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ToggleInteractive_Response_TypeSupportInterface> ToggleInteractive_Response_TypeSupportInterface_out;


            class ToggleInteractive_Response_DataWriter;

            typedef ToggleInteractive_Response_DataWriter * ToggleInteractive_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ToggleInteractive_Response_DataWriter> ToggleInteractive_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ToggleInteractive_Response_DataWriter> ToggleInteractive_Response_DataWriter_out;


            class ToggleInteractive_Response_DataReader;

            typedef ToggleInteractive_Response_DataReader * ToggleInteractive_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ToggleInteractive_Response_DataReader> ToggleInteractive_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ToggleInteractive_Response_DataReader> ToggleInteractive_Response_DataReader_out;


            class ToggleInteractive_Response_DataReaderView;

            typedef ToggleInteractive_Response_DataReaderView * ToggleInteractive_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ToggleInteractive_Response_DataReaderView> ToggleInteractive_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ToggleInteractive_Response_DataReaderView> ToggleInteractive_Response_DataReaderView_out;

            struct ToggleInteractive_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ToggleInteractive_Response_, struct ToggleInteractive_Response_Seq_uniq_> ToggleInteractive_Response_Seq;
            typedef DDS_DCPSSequence_var < ToggleInteractive_Response_Seq> ToggleInteractive_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ToggleInteractive_Response_Seq> ToggleInteractive_Response_Seq_out;

            class  ToggleInteractive_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ToggleInteractive_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ToggleInteractive_Response_TypeSupportInterface_var _var_type;

                static ToggleInteractive_Response_TypeSupportInterface_ptr _duplicate (ToggleInteractive_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ToggleInteractive_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ToggleInteractive_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ToggleInteractive_Response_TypeSupportInterface () {};
                ~ToggleInteractive_Response_TypeSupportInterface () {};
            private:
                ToggleInteractive_Response_TypeSupportInterface (const ToggleInteractive_Response_TypeSupportInterface &);
                ToggleInteractive_Response_TypeSupportInterface & operator = (const ToggleInteractive_Response_TypeSupportInterface &);
            };

            class  ToggleInteractive_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ToggleInteractive_Response_DataWriter_ptr _ptr_type;
                typedef ToggleInteractive_Response_DataWriter_var _var_type;

                static ToggleInteractive_Response_DataWriter_ptr _duplicate (ToggleInteractive_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ToggleInteractive_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ToggleInteractive_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ToggleInteractive_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ToggleInteractive_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ToggleInteractive_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ToggleInteractive_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ToggleInteractive_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ToggleInteractive_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ToggleInteractive_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ToggleInteractive_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ToggleInteractive_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ToggleInteractive_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ToggleInteractive_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ToggleInteractive_Response_& instance_data) = 0;

            protected:
                ToggleInteractive_Response_DataWriter () {};
                ~ToggleInteractive_Response_DataWriter () {};
            private:
                ToggleInteractive_Response_DataWriter (const ToggleInteractive_Response_DataWriter &);
                ToggleInteractive_Response_DataWriter & operator = (const ToggleInteractive_Response_DataWriter &);
            };

            class  ToggleInteractive_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ToggleInteractive_Response_DataReader_ptr _ptr_type;
                typedef ToggleInteractive_Response_DataReader_var _var_type;

                static ToggleInteractive_Response_DataReader_ptr _duplicate (ToggleInteractive_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ToggleInteractive_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ToggleInteractive_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ToggleInteractive_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ToggleInteractive_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ToggleInteractive_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ToggleInteractive_Response_& instance) = 0;

            protected:
                ToggleInteractive_Response_DataReader () {};
                ~ToggleInteractive_Response_DataReader () {};
            private:
                ToggleInteractive_Response_DataReader (const ToggleInteractive_Response_DataReader &);
                ToggleInteractive_Response_DataReader & operator = (const ToggleInteractive_Response_DataReader &);
            };

            class  ToggleInteractive_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ToggleInteractive_Response_DataReaderView_ptr _ptr_type;
                typedef ToggleInteractive_Response_DataReaderView_var _var_type;

                static ToggleInteractive_Response_DataReaderView_ptr _duplicate (ToggleInteractive_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ToggleInteractive_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ToggleInteractive_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ToggleInteractive_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ToggleInteractive_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ToggleInteractive_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ToggleInteractive_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ToggleInteractive_Response_& instance) = 0;

            protected:
                ToggleInteractive_Response_DataReaderView () {};
                ~ToggleInteractive_Response_DataReaderView () {};
            private:
                ToggleInteractive_Response_DataReaderView (const ToggleInteractive_Response_DataReaderView &);
                ToggleInteractive_Response_DataReaderView & operator = (const ToggleInteractive_Response_DataReaderView &);
            };
            class Sample_ToggleInteractive_Request_TypeSupportInterface;

            typedef Sample_ToggleInteractive_Request_TypeSupportInterface * Sample_ToggleInteractive_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ToggleInteractive_Request_TypeSupportInterface> Sample_ToggleInteractive_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ToggleInteractive_Request_TypeSupportInterface> Sample_ToggleInteractive_Request_TypeSupportInterface_out;


            class Sample_ToggleInteractive_Request_DataWriter;

            typedef Sample_ToggleInteractive_Request_DataWriter * Sample_ToggleInteractive_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ToggleInteractive_Request_DataWriter> Sample_ToggleInteractive_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ToggleInteractive_Request_DataWriter> Sample_ToggleInteractive_Request_DataWriter_out;


            class Sample_ToggleInteractive_Request_DataReader;

            typedef Sample_ToggleInteractive_Request_DataReader * Sample_ToggleInteractive_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ToggleInteractive_Request_DataReader> Sample_ToggleInteractive_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ToggleInteractive_Request_DataReader> Sample_ToggleInteractive_Request_DataReader_out;


            class Sample_ToggleInteractive_Request_DataReaderView;

            typedef Sample_ToggleInteractive_Request_DataReaderView * Sample_ToggleInteractive_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ToggleInteractive_Request_DataReaderView> Sample_ToggleInteractive_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ToggleInteractive_Request_DataReaderView> Sample_ToggleInteractive_Request_DataReaderView_out;

            struct Sample_ToggleInteractive_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_ToggleInteractive_Request_, struct Sample_ToggleInteractive_Request_Seq_uniq_> Sample_ToggleInteractive_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ToggleInteractive_Request_Seq> Sample_ToggleInteractive_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ToggleInteractive_Request_Seq> Sample_ToggleInteractive_Request_Seq_out;

            class  Sample_ToggleInteractive_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ToggleInteractive_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ToggleInteractive_Request_TypeSupportInterface_var _var_type;

                static Sample_ToggleInteractive_Request_TypeSupportInterface_ptr _duplicate (Sample_ToggleInteractive_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ToggleInteractive_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ToggleInteractive_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ToggleInteractive_Request_TypeSupportInterface () {};
                ~Sample_ToggleInteractive_Request_TypeSupportInterface () {};
            private:
                Sample_ToggleInteractive_Request_TypeSupportInterface (const Sample_ToggleInteractive_Request_TypeSupportInterface &);
                Sample_ToggleInteractive_Request_TypeSupportInterface & operator = (const Sample_ToggleInteractive_Request_TypeSupportInterface &);
            };

            class  Sample_ToggleInteractive_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ToggleInteractive_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ToggleInteractive_Request_DataWriter_var _var_type;

                static Sample_ToggleInteractive_Request_DataWriter_ptr _duplicate (Sample_ToggleInteractive_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ToggleInteractive_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ToggleInteractive_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ToggleInteractive_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ToggleInteractive_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ToggleInteractive_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ToggleInteractive_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ToggleInteractive_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ToggleInteractive_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ToggleInteractive_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ToggleInteractive_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ToggleInteractive_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ToggleInteractive_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ToggleInteractive_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ToggleInteractive_Request_& instance_data) = 0;

            protected:
                Sample_ToggleInteractive_Request_DataWriter () {};
                ~Sample_ToggleInteractive_Request_DataWriter () {};
            private:
                Sample_ToggleInteractive_Request_DataWriter (const Sample_ToggleInteractive_Request_DataWriter &);
                Sample_ToggleInteractive_Request_DataWriter & operator = (const Sample_ToggleInteractive_Request_DataWriter &);
            };

            class  Sample_ToggleInteractive_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ToggleInteractive_Request_DataReader_ptr _ptr_type;
                typedef Sample_ToggleInteractive_Request_DataReader_var _var_type;

                static Sample_ToggleInteractive_Request_DataReader_ptr _duplicate (Sample_ToggleInteractive_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ToggleInteractive_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ToggleInteractive_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ToggleInteractive_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ToggleInteractive_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ToggleInteractive_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ToggleInteractive_Request_& instance) = 0;

            protected:
                Sample_ToggleInteractive_Request_DataReader () {};
                ~Sample_ToggleInteractive_Request_DataReader () {};
            private:
                Sample_ToggleInteractive_Request_DataReader (const Sample_ToggleInteractive_Request_DataReader &);
                Sample_ToggleInteractive_Request_DataReader & operator = (const Sample_ToggleInteractive_Request_DataReader &);
            };

            class  Sample_ToggleInteractive_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ToggleInteractive_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ToggleInteractive_Request_DataReaderView_var _var_type;

                static Sample_ToggleInteractive_Request_DataReaderView_ptr _duplicate (Sample_ToggleInteractive_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ToggleInteractive_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ToggleInteractive_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ToggleInteractive_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ToggleInteractive_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ToggleInteractive_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ToggleInteractive_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ToggleInteractive_Request_& instance) = 0;

            protected:
                Sample_ToggleInteractive_Request_DataReaderView () {};
                ~Sample_ToggleInteractive_Request_DataReaderView () {};
            private:
                Sample_ToggleInteractive_Request_DataReaderView (const Sample_ToggleInteractive_Request_DataReaderView &);
                Sample_ToggleInteractive_Request_DataReaderView & operator = (const Sample_ToggleInteractive_Request_DataReaderView &);
            };
            class Sample_ToggleInteractive_Response_TypeSupportInterface;

            typedef Sample_ToggleInteractive_Response_TypeSupportInterface * Sample_ToggleInteractive_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ToggleInteractive_Response_TypeSupportInterface> Sample_ToggleInteractive_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ToggleInteractive_Response_TypeSupportInterface> Sample_ToggleInteractive_Response_TypeSupportInterface_out;


            class Sample_ToggleInteractive_Response_DataWriter;

            typedef Sample_ToggleInteractive_Response_DataWriter * Sample_ToggleInteractive_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ToggleInteractive_Response_DataWriter> Sample_ToggleInteractive_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ToggleInteractive_Response_DataWriter> Sample_ToggleInteractive_Response_DataWriter_out;


            class Sample_ToggleInteractive_Response_DataReader;

            typedef Sample_ToggleInteractive_Response_DataReader * Sample_ToggleInteractive_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ToggleInteractive_Response_DataReader> Sample_ToggleInteractive_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ToggleInteractive_Response_DataReader> Sample_ToggleInteractive_Response_DataReader_out;


            class Sample_ToggleInteractive_Response_DataReaderView;

            typedef Sample_ToggleInteractive_Response_DataReaderView * Sample_ToggleInteractive_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ToggleInteractive_Response_DataReaderView> Sample_ToggleInteractive_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ToggleInteractive_Response_DataReaderView> Sample_ToggleInteractive_Response_DataReaderView_out;

            struct Sample_ToggleInteractive_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_ToggleInteractive_Response_, struct Sample_ToggleInteractive_Response_Seq_uniq_> Sample_ToggleInteractive_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ToggleInteractive_Response_Seq> Sample_ToggleInteractive_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ToggleInteractive_Response_Seq> Sample_ToggleInteractive_Response_Seq_out;

            class  Sample_ToggleInteractive_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ToggleInteractive_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ToggleInteractive_Response_TypeSupportInterface_var _var_type;

                static Sample_ToggleInteractive_Response_TypeSupportInterface_ptr _duplicate (Sample_ToggleInteractive_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ToggleInteractive_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ToggleInteractive_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ToggleInteractive_Response_TypeSupportInterface () {};
                ~Sample_ToggleInteractive_Response_TypeSupportInterface () {};
            private:
                Sample_ToggleInteractive_Response_TypeSupportInterface (const Sample_ToggleInteractive_Response_TypeSupportInterface &);
                Sample_ToggleInteractive_Response_TypeSupportInterface & operator = (const Sample_ToggleInteractive_Response_TypeSupportInterface &);
            };

            class  Sample_ToggleInteractive_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ToggleInteractive_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ToggleInteractive_Response_DataWriter_var _var_type;

                static Sample_ToggleInteractive_Response_DataWriter_ptr _duplicate (Sample_ToggleInteractive_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ToggleInteractive_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ToggleInteractive_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ToggleInteractive_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ToggleInteractive_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ToggleInteractive_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ToggleInteractive_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ToggleInteractive_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ToggleInteractive_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ToggleInteractive_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ToggleInteractive_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ToggleInteractive_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ToggleInteractive_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ToggleInteractive_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ToggleInteractive_Response_& instance_data) = 0;

            protected:
                Sample_ToggleInteractive_Response_DataWriter () {};
                ~Sample_ToggleInteractive_Response_DataWriter () {};
            private:
                Sample_ToggleInteractive_Response_DataWriter (const Sample_ToggleInteractive_Response_DataWriter &);
                Sample_ToggleInteractive_Response_DataWriter & operator = (const Sample_ToggleInteractive_Response_DataWriter &);
            };

            class  Sample_ToggleInteractive_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ToggleInteractive_Response_DataReader_ptr _ptr_type;
                typedef Sample_ToggleInteractive_Response_DataReader_var _var_type;

                static Sample_ToggleInteractive_Response_DataReader_ptr _duplicate (Sample_ToggleInteractive_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ToggleInteractive_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ToggleInteractive_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ToggleInteractive_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ToggleInteractive_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ToggleInteractive_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ToggleInteractive_Response_& instance) = 0;

            protected:
                Sample_ToggleInteractive_Response_DataReader () {};
                ~Sample_ToggleInteractive_Response_DataReader () {};
            private:
                Sample_ToggleInteractive_Response_DataReader (const Sample_ToggleInteractive_Response_DataReader &);
                Sample_ToggleInteractive_Response_DataReader & operator = (const Sample_ToggleInteractive_Response_DataReader &);
            };

            class  Sample_ToggleInteractive_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ToggleInteractive_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ToggleInteractive_Response_DataReaderView_var _var_type;

                static Sample_ToggleInteractive_Response_DataReaderView_ptr _duplicate (Sample_ToggleInteractive_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ToggleInteractive_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ToggleInteractive_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ToggleInteractive_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ToggleInteractive_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ToggleInteractive_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ToggleInteractive_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ToggleInteractive_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ToggleInteractive_Response_& instance) = 0;

            protected:
                Sample_ToggleInteractive_Response_DataReaderView () {};
                ~Sample_ToggleInteractive_Response_DataReaderView () {};
            private:
                Sample_ToggleInteractive_Response_DataReaderView (const Sample_ToggleInteractive_Response_DataReaderView &);
                Sample_ToggleInteractive_Response_DataReaderView & operator = (const Sample_ToggleInteractive_Response_DataReaderView &);
            };
        }

    }

}

#endif
