#ifndef _H_AE817A880DBBC1EB2A17AD1153D99EF6_ClearQueue_DCPS_H_
#define _H_AE817A880DBBC1EB2A17AD1153D99EF6_ClearQueue_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ClearQueue_.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            class ClearQueue_Request_TypeSupportInterface;

            typedef ClearQueue_Request_TypeSupportInterface * ClearQueue_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ClearQueue_Request_TypeSupportInterface> ClearQueue_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ClearQueue_Request_TypeSupportInterface> ClearQueue_Request_TypeSupportInterface_out;


            class ClearQueue_Request_DataWriter;

            typedef ClearQueue_Request_DataWriter * ClearQueue_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ClearQueue_Request_DataWriter> ClearQueue_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ClearQueue_Request_DataWriter> ClearQueue_Request_DataWriter_out;


            class ClearQueue_Request_DataReader;

            typedef ClearQueue_Request_DataReader * ClearQueue_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ClearQueue_Request_DataReader> ClearQueue_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ClearQueue_Request_DataReader> ClearQueue_Request_DataReader_out;


            class ClearQueue_Request_DataReaderView;

            typedef ClearQueue_Request_DataReaderView * ClearQueue_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ClearQueue_Request_DataReaderView> ClearQueue_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ClearQueue_Request_DataReaderView> ClearQueue_Request_DataReaderView_out;

            struct ClearQueue_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ClearQueue_Request_, struct ClearQueue_Request_Seq_uniq_> ClearQueue_Request_Seq;
            typedef DDS_DCPSSequence_var < ClearQueue_Request_Seq> ClearQueue_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ClearQueue_Request_Seq> ClearQueue_Request_Seq_out;

            class  ClearQueue_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ClearQueue_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ClearQueue_Request_TypeSupportInterface_var _var_type;

                static ClearQueue_Request_TypeSupportInterface_ptr _duplicate (ClearQueue_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearQueue_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ClearQueue_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearQueue_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearQueue_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ClearQueue_Request_TypeSupportInterface () {};
                ~ClearQueue_Request_TypeSupportInterface () {};
            private:
                ClearQueue_Request_TypeSupportInterface (const ClearQueue_Request_TypeSupportInterface &);
                ClearQueue_Request_TypeSupportInterface & operator = (const ClearQueue_Request_TypeSupportInterface &);
            };

            class  ClearQueue_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ClearQueue_Request_DataWriter_ptr _ptr_type;
                typedef ClearQueue_Request_DataWriter_var _var_type;

                static ClearQueue_Request_DataWriter_ptr _duplicate (ClearQueue_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearQueue_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ClearQueue_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearQueue_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearQueue_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ClearQueue_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ClearQueue_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ClearQueue_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ClearQueue_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ClearQueue_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ClearQueue_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ClearQueue_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ClearQueue_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ClearQueue_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ClearQueue_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ClearQueue_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClearQueue_Request_& instance_data) = 0;

            protected:
                ClearQueue_Request_DataWriter () {};
                ~ClearQueue_Request_DataWriter () {};
            private:
                ClearQueue_Request_DataWriter (const ClearQueue_Request_DataWriter &);
                ClearQueue_Request_DataWriter & operator = (const ClearQueue_Request_DataWriter &);
            };

            class  ClearQueue_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ClearQueue_Request_DataReader_ptr _ptr_type;
                typedef ClearQueue_Request_DataReader_var _var_type;

                static ClearQueue_Request_DataReader_ptr _duplicate (ClearQueue_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearQueue_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ClearQueue_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearQueue_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearQueue_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClearQueue_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClearQueue_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClearQueue_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClearQueue_Request_& instance) = 0;

            protected:
                ClearQueue_Request_DataReader () {};
                ~ClearQueue_Request_DataReader () {};
            private:
                ClearQueue_Request_DataReader (const ClearQueue_Request_DataReader &);
                ClearQueue_Request_DataReader & operator = (const ClearQueue_Request_DataReader &);
            };

            class  ClearQueue_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ClearQueue_Request_DataReaderView_ptr _ptr_type;
                typedef ClearQueue_Request_DataReaderView_var _var_type;

                static ClearQueue_Request_DataReaderView_ptr _duplicate (ClearQueue_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearQueue_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ClearQueue_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearQueue_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearQueue_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClearQueue_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClearQueue_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClearQueue_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClearQueue_Request_& instance) = 0;

            protected:
                ClearQueue_Request_DataReaderView () {};
                ~ClearQueue_Request_DataReaderView () {};
            private:
                ClearQueue_Request_DataReaderView (const ClearQueue_Request_DataReaderView &);
                ClearQueue_Request_DataReaderView & operator = (const ClearQueue_Request_DataReaderView &);
            };
            class ClearQueue_Response_TypeSupportInterface;

            typedef ClearQueue_Response_TypeSupportInterface * ClearQueue_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ClearQueue_Response_TypeSupportInterface> ClearQueue_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ClearQueue_Response_TypeSupportInterface> ClearQueue_Response_TypeSupportInterface_out;


            class ClearQueue_Response_DataWriter;

            typedef ClearQueue_Response_DataWriter * ClearQueue_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ClearQueue_Response_DataWriter> ClearQueue_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ClearQueue_Response_DataWriter> ClearQueue_Response_DataWriter_out;


            class ClearQueue_Response_DataReader;

            typedef ClearQueue_Response_DataReader * ClearQueue_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ClearQueue_Response_DataReader> ClearQueue_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ClearQueue_Response_DataReader> ClearQueue_Response_DataReader_out;


            class ClearQueue_Response_DataReaderView;

            typedef ClearQueue_Response_DataReaderView * ClearQueue_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ClearQueue_Response_DataReaderView> ClearQueue_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ClearQueue_Response_DataReaderView> ClearQueue_Response_DataReaderView_out;

            struct ClearQueue_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ClearQueue_Response_, struct ClearQueue_Response_Seq_uniq_> ClearQueue_Response_Seq;
            typedef DDS_DCPSSequence_var < ClearQueue_Response_Seq> ClearQueue_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ClearQueue_Response_Seq> ClearQueue_Response_Seq_out;

            class  ClearQueue_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ClearQueue_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ClearQueue_Response_TypeSupportInterface_var _var_type;

                static ClearQueue_Response_TypeSupportInterface_ptr _duplicate (ClearQueue_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearQueue_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ClearQueue_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearQueue_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearQueue_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ClearQueue_Response_TypeSupportInterface () {};
                ~ClearQueue_Response_TypeSupportInterface () {};
            private:
                ClearQueue_Response_TypeSupportInterface (const ClearQueue_Response_TypeSupportInterface &);
                ClearQueue_Response_TypeSupportInterface & operator = (const ClearQueue_Response_TypeSupportInterface &);
            };

            class  ClearQueue_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ClearQueue_Response_DataWriter_ptr _ptr_type;
                typedef ClearQueue_Response_DataWriter_var _var_type;

                static ClearQueue_Response_DataWriter_ptr _duplicate (ClearQueue_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearQueue_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ClearQueue_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearQueue_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearQueue_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ClearQueue_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ClearQueue_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ClearQueue_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ClearQueue_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ClearQueue_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ClearQueue_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ClearQueue_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ClearQueue_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ClearQueue_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ClearQueue_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ClearQueue_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClearQueue_Response_& instance_data) = 0;

            protected:
                ClearQueue_Response_DataWriter () {};
                ~ClearQueue_Response_DataWriter () {};
            private:
                ClearQueue_Response_DataWriter (const ClearQueue_Response_DataWriter &);
                ClearQueue_Response_DataWriter & operator = (const ClearQueue_Response_DataWriter &);
            };

            class  ClearQueue_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ClearQueue_Response_DataReader_ptr _ptr_type;
                typedef ClearQueue_Response_DataReader_var _var_type;

                static ClearQueue_Response_DataReader_ptr _duplicate (ClearQueue_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearQueue_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ClearQueue_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearQueue_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearQueue_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClearQueue_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClearQueue_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClearQueue_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClearQueue_Response_& instance) = 0;

            protected:
                ClearQueue_Response_DataReader () {};
                ~ClearQueue_Response_DataReader () {};
            private:
                ClearQueue_Response_DataReader (const ClearQueue_Response_DataReader &);
                ClearQueue_Response_DataReader & operator = (const ClearQueue_Response_DataReader &);
            };

            class  ClearQueue_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ClearQueue_Response_DataReaderView_ptr _ptr_type;
                typedef ClearQueue_Response_DataReaderView_var _var_type;

                static ClearQueue_Response_DataReaderView_ptr _duplicate (ClearQueue_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClearQueue_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ClearQueue_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClearQueue_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ClearQueue_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClearQueue_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClearQueue_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClearQueue_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClearQueue_Response_& instance) = 0;

            protected:
                ClearQueue_Response_DataReaderView () {};
                ~ClearQueue_Response_DataReaderView () {};
            private:
                ClearQueue_Response_DataReaderView (const ClearQueue_Response_DataReaderView &);
                ClearQueue_Response_DataReaderView & operator = (const ClearQueue_Response_DataReaderView &);
            };
            class Sample_ClearQueue_Request_TypeSupportInterface;

            typedef Sample_ClearQueue_Request_TypeSupportInterface * Sample_ClearQueue_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearQueue_Request_TypeSupportInterface> Sample_ClearQueue_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ClearQueue_Request_TypeSupportInterface> Sample_ClearQueue_Request_TypeSupportInterface_out;


            class Sample_ClearQueue_Request_DataWriter;

            typedef Sample_ClearQueue_Request_DataWriter * Sample_ClearQueue_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearQueue_Request_DataWriter> Sample_ClearQueue_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ClearQueue_Request_DataWriter> Sample_ClearQueue_Request_DataWriter_out;


            class Sample_ClearQueue_Request_DataReader;

            typedef Sample_ClearQueue_Request_DataReader * Sample_ClearQueue_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearQueue_Request_DataReader> Sample_ClearQueue_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ClearQueue_Request_DataReader> Sample_ClearQueue_Request_DataReader_out;


            class Sample_ClearQueue_Request_DataReaderView;

            typedef Sample_ClearQueue_Request_DataReaderView * Sample_ClearQueue_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearQueue_Request_DataReaderView> Sample_ClearQueue_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ClearQueue_Request_DataReaderView> Sample_ClearQueue_Request_DataReaderView_out;

            struct Sample_ClearQueue_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_ClearQueue_Request_, struct Sample_ClearQueue_Request_Seq_uniq_> Sample_ClearQueue_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ClearQueue_Request_Seq> Sample_ClearQueue_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ClearQueue_Request_Seq> Sample_ClearQueue_Request_Seq_out;

            class  Sample_ClearQueue_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ClearQueue_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ClearQueue_Request_TypeSupportInterface_var _var_type;

                static Sample_ClearQueue_Request_TypeSupportInterface_ptr _duplicate (Sample_ClearQueue_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearQueue_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearQueue_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ClearQueue_Request_TypeSupportInterface () {};
                ~Sample_ClearQueue_Request_TypeSupportInterface () {};
            private:
                Sample_ClearQueue_Request_TypeSupportInterface (const Sample_ClearQueue_Request_TypeSupportInterface &);
                Sample_ClearQueue_Request_TypeSupportInterface & operator = (const Sample_ClearQueue_Request_TypeSupportInterface &);
            };

            class  Sample_ClearQueue_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ClearQueue_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ClearQueue_Request_DataWriter_var _var_type;

                static Sample_ClearQueue_Request_DataWriter_ptr _duplicate (Sample_ClearQueue_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearQueue_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearQueue_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ClearQueue_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ClearQueue_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ClearQueue_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ClearQueue_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ClearQueue_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ClearQueue_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ClearQueue_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ClearQueue_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ClearQueue_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ClearQueue_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ClearQueue_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClearQueue_Request_& instance_data) = 0;

            protected:
                Sample_ClearQueue_Request_DataWriter () {};
                ~Sample_ClearQueue_Request_DataWriter () {};
            private:
                Sample_ClearQueue_Request_DataWriter (const Sample_ClearQueue_Request_DataWriter &);
                Sample_ClearQueue_Request_DataWriter & operator = (const Sample_ClearQueue_Request_DataWriter &);
            };

            class  Sample_ClearQueue_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ClearQueue_Request_DataReader_ptr _ptr_type;
                typedef Sample_ClearQueue_Request_DataReader_var _var_type;

                static Sample_ClearQueue_Request_DataReader_ptr _duplicate (Sample_ClearQueue_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearQueue_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearQueue_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ClearQueue_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ClearQueue_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ClearQueue_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClearQueue_Request_& instance) = 0;

            protected:
                Sample_ClearQueue_Request_DataReader () {};
                ~Sample_ClearQueue_Request_DataReader () {};
            private:
                Sample_ClearQueue_Request_DataReader (const Sample_ClearQueue_Request_DataReader &);
                Sample_ClearQueue_Request_DataReader & operator = (const Sample_ClearQueue_Request_DataReader &);
            };

            class  Sample_ClearQueue_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ClearQueue_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ClearQueue_Request_DataReaderView_var _var_type;

                static Sample_ClearQueue_Request_DataReaderView_ptr _duplicate (Sample_ClearQueue_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearQueue_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearQueue_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ClearQueue_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ClearQueue_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ClearQueue_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ClearQueue_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClearQueue_Request_& instance) = 0;

            protected:
                Sample_ClearQueue_Request_DataReaderView () {};
                ~Sample_ClearQueue_Request_DataReaderView () {};
            private:
                Sample_ClearQueue_Request_DataReaderView (const Sample_ClearQueue_Request_DataReaderView &);
                Sample_ClearQueue_Request_DataReaderView & operator = (const Sample_ClearQueue_Request_DataReaderView &);
            };
            class Sample_ClearQueue_Response_TypeSupportInterface;

            typedef Sample_ClearQueue_Response_TypeSupportInterface * Sample_ClearQueue_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearQueue_Response_TypeSupportInterface> Sample_ClearQueue_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ClearQueue_Response_TypeSupportInterface> Sample_ClearQueue_Response_TypeSupportInterface_out;


            class Sample_ClearQueue_Response_DataWriter;

            typedef Sample_ClearQueue_Response_DataWriter * Sample_ClearQueue_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearQueue_Response_DataWriter> Sample_ClearQueue_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ClearQueue_Response_DataWriter> Sample_ClearQueue_Response_DataWriter_out;


            class Sample_ClearQueue_Response_DataReader;

            typedef Sample_ClearQueue_Response_DataReader * Sample_ClearQueue_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearQueue_Response_DataReader> Sample_ClearQueue_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ClearQueue_Response_DataReader> Sample_ClearQueue_Response_DataReader_out;


            class Sample_ClearQueue_Response_DataReaderView;

            typedef Sample_ClearQueue_Response_DataReaderView * Sample_ClearQueue_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ClearQueue_Response_DataReaderView> Sample_ClearQueue_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ClearQueue_Response_DataReaderView> Sample_ClearQueue_Response_DataReaderView_out;

            struct Sample_ClearQueue_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_ClearQueue_Response_, struct Sample_ClearQueue_Response_Seq_uniq_> Sample_ClearQueue_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ClearQueue_Response_Seq> Sample_ClearQueue_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ClearQueue_Response_Seq> Sample_ClearQueue_Response_Seq_out;

            class  Sample_ClearQueue_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ClearQueue_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ClearQueue_Response_TypeSupportInterface_var _var_type;

                static Sample_ClearQueue_Response_TypeSupportInterface_ptr _duplicate (Sample_ClearQueue_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearQueue_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearQueue_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ClearQueue_Response_TypeSupportInterface () {};
                ~Sample_ClearQueue_Response_TypeSupportInterface () {};
            private:
                Sample_ClearQueue_Response_TypeSupportInterface (const Sample_ClearQueue_Response_TypeSupportInterface &);
                Sample_ClearQueue_Response_TypeSupportInterface & operator = (const Sample_ClearQueue_Response_TypeSupportInterface &);
            };

            class  Sample_ClearQueue_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ClearQueue_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ClearQueue_Response_DataWriter_var _var_type;

                static Sample_ClearQueue_Response_DataWriter_ptr _duplicate (Sample_ClearQueue_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearQueue_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearQueue_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ClearQueue_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ClearQueue_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ClearQueue_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ClearQueue_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ClearQueue_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ClearQueue_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ClearQueue_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ClearQueue_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ClearQueue_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ClearQueue_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ClearQueue_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClearQueue_Response_& instance_data) = 0;

            protected:
                Sample_ClearQueue_Response_DataWriter () {};
                ~Sample_ClearQueue_Response_DataWriter () {};
            private:
                Sample_ClearQueue_Response_DataWriter (const Sample_ClearQueue_Response_DataWriter &);
                Sample_ClearQueue_Response_DataWriter & operator = (const Sample_ClearQueue_Response_DataWriter &);
            };

            class  Sample_ClearQueue_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ClearQueue_Response_DataReader_ptr _ptr_type;
                typedef Sample_ClearQueue_Response_DataReader_var _var_type;

                static Sample_ClearQueue_Response_DataReader_ptr _duplicate (Sample_ClearQueue_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearQueue_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearQueue_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ClearQueue_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ClearQueue_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ClearQueue_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClearQueue_Response_& instance) = 0;

            protected:
                Sample_ClearQueue_Response_DataReader () {};
                ~Sample_ClearQueue_Response_DataReader () {};
            private:
                Sample_ClearQueue_Response_DataReader (const Sample_ClearQueue_Response_DataReader &);
                Sample_ClearQueue_Response_DataReader & operator = (const Sample_ClearQueue_Response_DataReader &);
            };

            class  Sample_ClearQueue_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ClearQueue_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ClearQueue_Response_DataReaderView_var _var_type;

                static Sample_ClearQueue_Response_DataReaderView_ptr _duplicate (Sample_ClearQueue_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ClearQueue_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ClearQueue_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ClearQueue_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ClearQueue_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ClearQueue_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ClearQueue_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ClearQueue_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ClearQueue_Response_& instance) = 0;

            protected:
                Sample_ClearQueue_Response_DataReaderView () {};
                ~Sample_ClearQueue_Response_DataReaderView () {};
            private:
                Sample_ClearQueue_Response_DataReaderView (const Sample_ClearQueue_Response_DataReaderView &);
                Sample_ClearQueue_Response_DataReaderView & operator = (const Sample_ClearQueue_Response_DataReaderView &);
            };
        }

    }

}

#endif
