#ifndef _H_14059351A3F3A6DDF6642B2015AE2039_DeserializePoseGraph__H_
#define _H_14059351A3F3A6DDF6642B2015AE2039_DeserializePoseGraph__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Pose2D_.h"


namespace slam_toolbox
{
    namespace srv
    {
        namespace dds_
        {
            namespace DeserializePoseGraph_Request_Constants
            {
                const ::DDS::Octet UNSET_ = 0;

                const ::DDS::Octet START_AT_FIRST_NODE_ = 1;

                const ::DDS::Octet START_AT_GIVEN_POSE_ = 2;

                const ::DDS::Octet LOCALIZE_AT_POSE_ = 3;

            }

            struct  DeserializePoseGraph_Request_
            {
                ::DDS::String_mgr filename_;
                ::DDS::Octet match_type_;
                ::geometry_msgs::msg::dds_::Pose2D_ initial_pose_;
            };

            typedef DDS_DCPSStruct_var<DeserializePoseGraph_Request_> DeserializePoseGraph_Request__var;
            typedef DDS_DCPSStruct_out < DeserializePoseGraph_Request_> DeserializePoseGraph_Request__out;

            struct  DeserializePoseGraph_Response_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<DeserializePoseGraph_Response_> DeserializePoseGraph_Response__var;
            typedef DeserializePoseGraph_Response_& DeserializePoseGraph_Response__out;

            struct  Sample_DeserializePoseGraph_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::DeserializePoseGraph_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_DeserializePoseGraph_Request_> Sample_DeserializePoseGraph_Request__var;
            typedef DDS_DCPSStruct_out < Sample_DeserializePoseGraph_Request_> Sample_DeserializePoseGraph_Request__out;

            struct  Sample_DeserializePoseGraph_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::slam_toolbox::srv::dds_::DeserializePoseGraph_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_DeserializePoseGraph_Response_> Sample_DeserializePoseGraph_Response__var;
            typedef Sample_DeserializePoseGraph_Response_& Sample_DeserializePoseGraph_Response__out;

        }

    }

}

#endif /* _H_14059351A3F3A6DDF6642B2015AE2039_DeserializePoseGraph__H_ */
