// generated from rosidl_typesupport_connext_cpp/resource/idl__rosidl_typesupport_connext_cpp.hpp.em
// with input from slam_toolbox:srv/LoopClosure.idl
// generated code does not contain a copyright notice


#ifndef SLAM_TOOLBOX__SRV__LOOP_CLOSURE__ROSIDL_TYPESUPPORT_CONNEXT_CPP_HPP_
#define SLAM_TOOLBOX__SRV__LOOP_CLOSURE__ROSIDL_TYPESUPPORT_CONNEXT_CPP_HPP_

#include "rosidl_generator_c/message_type_support_struct.h"
#include "rosidl_typesupport_interface/macros.h"
#include "slam_toolbox/msg/rosidl_typesupport_connext_cpp__visibility_control.h"
#include "slam_toolbox/srv/loop_closure__struct.hpp"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif

#include "slam_toolbox/srv/dds_connext/LoopClosure_Support.h"
#include "slam_toolbox/srv/dds_connext/LoopClosure_Plugin.h"
#include "ndds/ndds_cpp.h"

#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// forward declaration of internal CDR Stream
struct ConnextStaticCDRStream;

// forward declaration of DDS types
class DDSDomainParticipant;
class DDSDataWriter;
class DDSDataReader;


namespace slam_toolbox
{

namespace srv
{
namespace typesupport_connext_cpp
{

DDS_TypeCode *
get_type_code__LoopClosure_Request();

bool
ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
convert_ros_message_to_dds(
  const slam_toolbox::srv::LoopClosure_Request & ros_message,
  slam_toolbox::srv::dds_::LoopClosure_Request_ & dds_message);

bool
ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
convert_dds_message_to_ros(
  const slam_toolbox::srv::dds_::LoopClosure_Request_ & dds_message,
  slam_toolbox::srv::LoopClosure_Request & ros_message);

bool
to_cdr_stream__LoopClosure_Request(
  const void * untyped_ros_message,
  ConnextStaticCDRStream * cdr_stream);

bool
to_message__LoopClosure_Request(
  const ConnextStaticCDRStream * cdr_stream,
  void * untyped_ros_message);

}  // namespace typesupport_connext_cpp

}  // namespace srv

}  // namespace slam_toolbox


#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
  rosidl_typesupport_connext_cpp,
  slam_toolbox, srv,
  LoopClosure_Request)();

#ifdef __cplusplus
}
#endif


// already included above
// #include "rosidl_generator_c/message_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "slam_toolbox/msg/rosidl_typesupport_connext_cpp__visibility_control.h"
// already included above
// #include "slam_toolbox/srv/loop_closure__struct.hpp"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif

// already included above
// #include "slam_toolbox/srv/dds_connext/LoopClosure_Support.h"
// already included above
// #include "slam_toolbox/srv/dds_connext/LoopClosure_Plugin.h"
// already included above
// #include "ndds/ndds_cpp.h"

#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// forward declaration of internal CDR Stream
struct ConnextStaticCDRStream;

// forward declaration of DDS types
class DDSDomainParticipant;
class DDSDataWriter;
class DDSDataReader;


namespace slam_toolbox
{

namespace srv
{
namespace typesupport_connext_cpp
{

DDS_TypeCode *
get_type_code__LoopClosure_Response();

bool
ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
convert_ros_message_to_dds(
  const slam_toolbox::srv::LoopClosure_Response & ros_message,
  slam_toolbox::srv::dds_::LoopClosure_Response_ & dds_message);

bool
ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
convert_dds_message_to_ros(
  const slam_toolbox::srv::dds_::LoopClosure_Response_ & dds_message,
  slam_toolbox::srv::LoopClosure_Response & ros_message);

bool
to_cdr_stream__LoopClosure_Response(
  const void * untyped_ros_message,
  ConnextStaticCDRStream * cdr_stream);

bool
to_message__LoopClosure_Response(
  const ConnextStaticCDRStream * cdr_stream,
  void * untyped_ros_message);

}  // namespace typesupport_connext_cpp

}  // namespace srv

}  // namespace slam_toolbox


#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
  rosidl_typesupport_connext_cpp,
  slam_toolbox, srv,
  LoopClosure_Response)();

#ifdef __cplusplus
}
#endif


#include "rmw/types.h"
#include "rosidl_typesupport_cpp/service_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "slam_toolbox/msg/rosidl_typesupport_connext_cpp__visibility_control.h"

namespace slam_toolbox
{
namespace srv
{
namespace typesupport_connext_cpp
{

ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
void *
create_requester__LoopClosure(
  void * untyped_participant,
  const char * request_topic_str,
  const char * response_topic_str,
  const void * untyped_datareader_qos,
  const void * untyped_datawriter_qos,
  void ** untyped_reader,
  void ** untyped_writer,
  void * (*allocator)(size_t));

ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
const char *
destroy_requester__LoopClosure(
  void * untyped_requester,
  void (* deallocator)(void *));

ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
int64_t
send_request__LoopClosure(
  void * untyped_requester,
  const void * untyped_ros_request);

ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
void *
create_replier__LoopClosure(
  void * untyped_participant,
  const char * request_topic_str,
  const char * response_topic_str,
  const void * untyped_datareader_qos,
  const void * untyped_datawriter_qos,
  void ** untyped_reader,
  void ** untyped_writer,
  void * (*allocator)(size_t));

ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
const char *
destroy_replier__LoopClosure(
  void * untyped_replier,
  void (* deallocator)(void *));

ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
bool
take_request__LoopClosure(
  void * untyped_replier,
  rmw_request_id_t * request_header,
  void * untyped_ros_request);

ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
bool
take_response__LoopClosure(
  void * untyped_requester,
  rmw_request_id_t * request_header,
  void * untyped_ros_response);

ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
bool
send_response__LoopClosure(
  void * untyped_replier,
  const rmw_request_id_t * request_header,
  const void * untyped_ros_response);

ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
void *
get_request_datawriter__LoopClosure(void * untyped_requester);

ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
void *
get_reply_datareader__LoopClosure(void * untyped_requester);

ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
void *
get_request_datareader__LoopClosure(void * untyped_replier);

ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
void *
get_reply_datawriter__LoopClosure(void * untyped_replier);

}  // namespace typesupport_connext_cpp
}  // namespace srv
}  // namespace slam_toolbox

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_CONNEXT_CPP_PUBLIC_slam_toolbox
const rosidl_service_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(
  rosidl_typesupport_connext_cpp,
  slam_toolbox, srv,
  LoopClosure)();

#ifdef __cplusplus
}
#endif

#endif  // SLAM_TOOLBOX__SRV__LOOP_CLOSURE__ROSIDL_TYPESUPPORT_CONNEXT_CPP_HPP_
